Subject: Re: [dhcwg] I-D Action: draft-templin-duid-ipv6-01.txt

From: "Templin (US), Fred L" <[email-masked]>
Date: Tue, 12 Jan 2021 18:40:10 +0000

Bob, please see my subsequent reply to Eric Vyncke that discusses motivation:

https://mailarchive.ietf.org/arch/msg/ipv6/yOfWHSnt36Hvjr44OERjK0OFvhw/
https://mailarchive.ietf.org/arch/msg/dhcwg/YZq_aPf1C82ZFT_bTdXOXVXTPW0/

Per your comment, perhaps a new section on "motivation" could be added
to the draft?

Thanks - Fred

> -----Original Message-----
> From: Bob Hinden [mailto:[email-masked]]
> Sent: Tuesday, January 12, 2021 10:22 AM
> To: Templin (US), Fred L <[email-masked]>
> Cc: Bob Hinden <[email-masked]>; Mark Smith <[email-masked]>; dhcwg <[email-masked]>; IPv6 List
> <[email-masked]>; Dickson (US), Sean M <[email-masked]>
> Subject: Re: I-D Action: draft-templin-duid-ipv6-01.txt
> 
> Fred,
> 
> Mark asked:
> 
> "I don't understand what problem this is trying to solve or see any
> benefits of it. What is wrong with existing DUIDs?”
> 
> I have the same question.   I read the draft but have no idea why this is needed.
> 
> Bob
> 
> 
> > On Jan 12, 2021, at 8:26 AM, Templin (US), Fred L <[email-masked]> wrote:
> >
> > Mark, thanks for the comments. I gather your concern is for the longevity and
> > immutability of the IPv6 address that would go into the DUID, since DUIDs are
> > meant to identify the device and not change over time. But, there are IPv6
> > address generation methods that generate addresses not for the purpose of
> > assigning them to a physical interface (e.g., Ethernet, WiFi and the like), but
> > instead to provide a unique node ID for the device that never changes
> > [RFC7401][draft-ietf-drip-rid]. Also, [RFC7721] mentions several other IPv6
> > address generation methods that could be considered for use for generating
> > a unique node ID, and other IPv6 address generation methods intended to
> > create a unique node ID could be defined in the future.
> >
> > So, again, this is not about using an IPv6 address assigned to a physical interface
> > as a DUID; it is about using an IPv6 address that was intentionally generated to
> > be a unique identifier for the node and may also be assigned to a virtual interface.
> >
> > Thanks - Fred
> >
> >> -----Original Message-----
> >> From: Mark Smith [mailto:[email-masked]]
> >> Sent: Monday, January 11, 2021 5:32 PM
> >> To: Templin (US), Fred L <[email-masked]>
> >> Cc: [email-masked]; dhcwg <[email-masked]>; Dickson (US), Sean M <[email-masked]>
> >> Subject: Re: FW: I-D Action: draft-templin-duid-ipv6-01.txt
> >>
> >>
> >> Hi Fred,
> >>
> >> I don't understand what problem this is trying to solve or see any
> >> benefits of it. What is wrong with existing DUIDs?
> >>
> >> DHCP Unique IDentifiers are, per RFC 8415,
> >>
> >> "...  designed to be unique across all DHCP clients and servers, and stable
> >>   for any specific client or server.  That is, the DUID used by a
> >>   client or server SHOULD NOT change over time if at all possible; for
> >>   example, a device's DUID should not change as a result of a change in
> >>   the device's network hardware or changes to virtual interfaces (e.g.,
> >>
> >>
> >>
> >>
> >> Mrugalski, et al.            Standards Track                   [Page 32]
> >>
> >> ________________________________
> >>
> >>
> >> RFC 8415                      DHCP for IPv6                November 2018
> >>
> >>
> >>   logical PPP (over Ethernet) interfaces that may come and go in
> >>   Customer Premises Equipment routers).  The client may change its DUID
> >>   as specified in [RFC7844]."
> >>
> >> The only IPv6 address that I can think of that might come close to
> >> meeting those requirements would be an EUI-64 derived Link-Local
> >> address, and that is assuming that the EUI-64/hardware MAC address
> >> never changes. MAC address randomisation and the RFC8064
> >> recommendation for use of RFC7217 for SLAAC means that Link-Local
> >> addresses may not meet the DUID requirements above either (RFC7217 can
> >> result in link-specific link-local addresses (specifically the IID
> >> portion is link specifc), even though the link-local prefix itself is
> >> constant across all links).
> >>
> >> There's also a circular dependency if the DUID is based on a GUA or
> >> ULA address and DHCPv6 is to then be used for stateful GAU/ULA address
> >> assignment, unless you mandated that SLAAC and stateful DHCPv6 are
> >> used in parallel so that SLAAC could be used to derive the DUID that
> >> is then used to acquire further ULA/GUA addresses via stateful DHCPv6
> >> IA_NAs and IA_TAs.
> >>
> >> "The DUID-V6ADDR may appear in DHCPv6 and/or other protocol control
> >>   messages (such as IPv6 ND) within a service domain when a unique ID
> >>   based on an IPv6 address is required."
> >>
> >> In the latter case, why not use IPv6 addresses themselves? Using
> >> DHCPv6 Unique Identifiers outside of the DHCP protocol would be an
> >> abuse of a DUID.
> >>
> >> Regards,
> >> Mark.
> >>
> >> On Tue, 12 Jan 2021 at 05:47, Templin (US), Fred L
> >> <[email-masked]> wrote:
> >>>
> >>> Hi, more and more IPv6 address generation methods are being specified that
> >>> intend to generate IPv6 addresses that are highly likely to be unique on either
> >>> a global scale or unique within a bounded service domain. So much so, that
> >>> some address generation methods intend for the IPv6 addresses to be usable
> >>> as node identifiers.
> >>>
> >>> Recognizing this, this document proposes a new DHCPv6 DUID type known
> >>> as "DHCP-V6ADDR" that includes an IPv6 address in the body of the DUID. In
> >>> this way, IPv6 addresses produced by address generation methods intending
> >>> to generate a node ID can be used as unique identifiers in DHCPv6 message
> >>> exchanges. This would introduce a single new DUID type, for which the IANA
> >>> allocation policy is  "standards action".
> >>>
> >>> Alternatively, a separate DUID type could be allocated for each IPv6 address
> >>> generation method. However, that approach may result in additional IANA
> >>> allocations and would require implementation updates every time a new
> >>> address generation method is specified. Hence, a single generic DUID type
> >>> for all IPv6 generation methods is proposed, but open for discussion.
> >>>
> >>> Comments on the list welcome.
> >>>
> >>> Fred
> >>>
> >>> -----Original Message-----
> >>> From: I-D-Announce [mailto:[email-masked]] On Behalf Of [email-masked]
> >>> Sent: Monday, January 11, 2021 10:21 AM
> >>> To: [email-masked]
> >>> Subject: I-D Action: draft-templin-duid-ipv6-01.txt
> >>>
> >>> A New Internet-Draft is available from the on-line Internet-Drafts directories.
> >>>
> >>>
> >>>        Title           : The IPv6 Address-based DHCPv6 Unique Identifier (DUID-V6ADDR)
> >>>        Author          : Fred L. Templin
> >>>        Filename        : draft-templin-duid-ipv6-01.txt
> >>>        Pages           : 7
> >>>        Date            : 2021-01-11
> >>>
> >>> Abstract:
> >>>   This document defines a new DHCPv6 Unique Identifier (DUID) type
> >>>   called DUID-V6ADDR that contains a single 128 bit IPv6 address.
> >>>   DUID-V6ADDR makes it possible for devices to use suitably-derived
> >>>   unique IPv6 addresses to identify themselves to DHCPv6 servers and/or
> >>>   other network nodes.
> >>>
> >>>
> >>> The IETF datatracker status page for this draft is:
> >>> https://datatracker.ietf.org/doc/draft-templin-duid-ipv6/
> >>>
> >>> There are also htmlized versions available at:
> >>> https://tools.ietf.org/html/draft-templin-duid-ipv6-01
> >>> https://datatracker.ietf.org/doc/html/draft-templin-duid-ipv6-01
> >>>
> >>> A diff from the previous version is available at:
> >>> https://www.ietf.org/rfcdiff?url2=draft-templin-duid-ipv6-01
> >>>
> >>>
> >>> Please note that it may take a couple of minutes from the time of submission
> >>> until the htmlized version and diff are available at tools.ietf.org.
> >>>
> >>> Internet-Drafts are also available by anonymous FTP at:
> >>> ftp://ftp.ietf.org/internet-drafts/
> >>>
> >>>
> >>> _______________________________________________
> >>> I-D-Announce mailing list
> >>> [email-masked]
> >>> https://www.ietf.org/mailman/listinfo/i-d-announce
> >>> Internet-Draft directories: http://www.ietf.org/shadow.html
> >>> or ftp://ftp.ietf.org/ietf/1shadow-sites.txt
> >>>
> >>> --------------------------------------------------------------------
> >>> IETF IPv6 working group mailing list
> >>> [email-masked]
> >>> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> >>> --------------------------------------------------------------------
> > --------------------------------------------------------------------
> > IETF IPv6 working group mailing list
> > [email-masked]
> > Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> > --------------------------------------------------------------------

---

From: Bob Hinden <[email-masked]>
Date: Tue, 12 Jan 2021 12:55:41 -0800

Fred,

> On Jan 12, 2021, at 10:40 AM, Templin (US), Fred L <[email-masked]> wrote:
> 

Sorry, I didn’t see an answer is why is this needed.  At the moment I don’t see a justification for this draft.

Bob

---

From: [email-masked]
Date: Tue, 12 Jan 2021 22:34:23 +0100

Fred,

It's unclear to me what the purpose of putting an IPv6 address in the DUID is. Would you mind clarifying that?

Are you also aware of the following restriction in RFC8415:
   "Clients and servers MUST treat DUIDs as opaque values and MUST only
   compare DUIDs for equality.  Clients and servers SHOULD NOT in any
   other way interpret DUIDs."

Best regards,
Ole

> On 12 Jan 2021, at 19:40, Templin (US), Fred L <[email-masked]> wrote:
>

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Tue, 12 Jan 2021 23:05:53 +0000

Ole,

> From: [email-masked] [mailto:[email-masked]]
> Sent: Tuesday, January 12, 2021 1:34 PM
> Cc: Bob Hinden <[email-masked]>; dhcwg <[email-masked]>; 6man WG <[email-masked]>; Dickson (US), Sean M
> <[email-masked]>
> Subject: [EXTERNAL] Re: I-D Action: draft-templin-duid-ipv6-01.txt
> 
> Fred,
> 

I will add words to the next draft version.

>    other way interpret DUIDs."

Yes, but then what is the reason why we currently have 4 DUID types instead
of just 1? If the text you quoted above is all there was to it, and end of story,
there would never be a need to differentiate DUID-LL from DUID-LLA from
DUID-EN from DUID-UUID. So, this suggests there is more to the story than
just the short text you quoted above. And, the community has supported the
definition of new DUIDs in the past (e.g., DUID-UUID).

Thanks - Fred

---

From: Bob Hinden <[email-masked]>
Date: Tue, 12 Jan 2021 16:43:20 -0800

Fred,

> On Jan 12, 2021, at 3:05 PM, Templin (US), Fred L <[email-masked]> wrote:
> 
> Ole,
> 

How about telling us now.

Bob

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Thu, 14 Jan 2021 16:19:11 +0000

Bob, I have been offline until just now due to windstorms that knocked out power
and Internet access in the Seattle area over the past couple of days. I will reply to
your question shortly.

Fred

> Sent: Tuesday, January 12, 2021 4:43 PM
> Cc: Bob Hinden <[email-masked]>; Ole Trøan <[email-masked]>; dhcwg <[email-masked]>; IPv6 List <[email-masked]>;
> Dickson (US), Sean M <[email-masked]>

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Thu, 14 Jan 2021 16:53:47 +0000

Bob, I think the answer to your question is quite simple. RFC8415, Section 11
provides the motivation for having more than one type of DUID, and RFC6355
is an example of how new DUID types are added through standards action.
The precedent for adding new DUID types according to published procedures
is therefore established.

In the specific instance of the proposal for establishing a new DUID type to carry
an IPv6 address, the intended use case is for IPv6 address generation methods
that produce an address that is designed to be a unique and stable identifier for
the node, which meets the requirements of what can be used as a DUID per
RFC8415, Section 11. This is certainly the case for (H)HIT per RFC7401 and
draft-ietf-drip-rid, and I suppose the same case could be made for other
cryptographically generated IPv6 addresses such as RFC3972. Future IPv6
address generation methods (whether or not cryptographic) could also be
designed to produce a unique and stable identifier for the node, and would
be covered under the proposed new DUID type as well.

Before we go down the rathole of "IPv6 addresses must be assigned to an
interface and not a node", please refer to the earlier messages on this thread
where the suggestion was made that the stable and unique address could be
assigned to a virtual interface (e.g., a loopback) and not an interface that may
be subject to change such as due to a hot-swap of an interface card. Finally,
RFC4291 says the following:

   "IPv6 addresses of all types are assigned to interfaces, not nodes.
   An IPv6 unicast address refers to a single interface.  Since each
   interface belongs to a single node, any of that node's interfaces'
   unicast addresses may be used as an identifier for the node."

From this text, we see that an IPv6 address may be used as an identifier for
the node, which is exactly what a DUID is. And, an IPv6 address is unlike any
of the existing DUID types, since by definition the address must be in the
format specified by RFC4291. Hence, a new DUID type is requested.

Fred

> From: dhcwg [mailto:[email-masked]] On Behalf Of Templin (US), Fred L
> Sent: Thursday, January 14, 2021 8:19 AM
> To: Bob Hinden <[email-masked]>
> Cc: dhcwg <[email-masked]>; IPv6 List <[email-masked]>; Dickson (US), Sean M <[email-masked]>
> Subject: Re: [dhcwg] [EXTERNAL] Re: I-D Action: draft-templin-duid-ipv6-01.txt
> 
> dhcwg mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dhcwg

---

From: Bob Hinden <[email-masked]>
Date: Thu, 14 Jan 2021 10:43:49 -0800

Fred,

> On Jan 14, 2021, at 8:53 AM, Templin (US), Fred L <[email-masked]> wrote:
> 

That wasn’t the question.   I didn’t ask if other types of DUID were allowed,  I asked:

 "It's unclear to me what the purpose of putting an IPv6 address in the DUID is. Would you mind clarifying that?”

Several other people asked similar questions.

> be covered under the proposed new DUID type as well.

Again, why do you need to use an IPv6 address for this?    Why can’t one of the current DUID approaches be used?

I note that DHCPv6 is usually used to get an IPv6 address, so using an IPv6 to get an IPv6 address seems very odd.

Bob

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Thu, 14 Jan 2021 19:46:10 +0000

Bob,

> Sent: Thursday, January 14, 2021 10:44 AM
> Cc: Bob Hinden <[email-masked]>; dhcwg <[email-masked]>; IPv6 List <[email-masked]>; Dickson (US), Sean M
> That wasn’t the question.   I didn’t ask if other types of DUID were allowed,

A different poster (Ole) made an assertion that seemed to call into question
why more than one DUID type is necessary - the above text was included to
to justify why multiple DUIDs are provided by RFC8415, and why additional
DUIDs can be added through future standards actions.

> I asked:

[RFC7401] and [draft-ietf-drip-rid] are examples of IPv6 address generation
methods that generate an address intended to be used as an *identity* but
possible not as a *locator*. In other words, the address could appear in control
message ID fields but may or may not be "ping'able" in the data plane. And,
even if it were "ping'able", pervasive use of the address for data communications
could present an unacceptable privacy exposure.

> I note that DHCPv6 is usually used to get an IPv6 address, so using an IPv6 to get an IPv6 address seems very odd.

Continuing from what I said above, yes this would entail using one type of IPv6
address (a pure identifier) to obtain one or more IPv6 addresses or prefixes that
can be used as the source/destination addresses for IPv6 data plane packets.

Fred

---

From: Ole Troan <[email-masked]>
Date: Thu, 14 Jan 2021 21:29:57 +0100

> On 14 Jan 2021, at 20:46, Templin (US), Fred L <[email-masked]> wrote:
> 

No. I questioned the purpose of having an IPv6 address in something that’s supposed to be an opaque identifier. 

Cheers 
Ole

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Thu, 14 Jan 2021 20:42:30 +0000

> From: Ole Troan [mailto:[email-masked]]
> Sent: Thursday, January 14, 2021 12:30 PM

And, I said that if it were *truly* opaque to *all* examinations and references, then
there would only ever be *one* DUID type for all time. But, RFC8415 clearly shows
that multiple DUID types are defined and that new ones can be added through
future standards action.

> Ole=

---

From: Simon Hobson <[email-masked]>
Date: Fri, 15 Jan 2021 14:07:44 +0000

> that multiple DUID types are defined and that new ones can be added through

Ah, you are starting from a false premise there.

Just because something is opaque and never ever (in theory) used in any way other than "X == Y" doesn't mean there's no reason to only ever have one method of creating it.
As the idea of DUID is that it should be globally unique, ideally the method used to create it should have the most sources of entropy possible. But different devices have different constraints. That's why we have LL and LLT since adding time of creation to the pot adds entropy, thus making LLT 'better' than LL, but some devices don't have a clock (and possibly, no persistent storage) making LLT unfeasible for them - i.e. LL is inferior to LLT, but real world constraints make it necessary.

So here the difference between LL and LLT is easy to see, as are the constraints that might force you to use the inferior one.

What people are asking you is : what makes this proposal so much better than what's already allowed, given that's what's in there is supposed to be opaque and so "it's an IPv6 address" has no bearing on it's "goodness" as a unique identifier. And more specifically, why is it better than an RFC4122 UUID as defined in RFC6355 - 'better' meaning sufficiently better to justify adding to the global code base required to support it.

Both are 16 octets/128 bits long, both are intended to be globally unique, both require persistent storage available to early boot loaders. So why is the proposed 128bit value better than the already defined 128bit value ?

Simon

---

From: Ted Lemon <[email-masked]>
Date: Fri, 15 Jan 2021 09:26:03 -0500

Also, why not use DUID-EN if you have a specific use case for this that is not something that makes sense to standardize?

> On Jan 15, 2021, at 09:08, Simon Hobson <[email-masked]> wrote:
>

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Fri, 15 Jan 2021 14:47:40 +0000

Fred:

I agree with Simon.

You have not explained why you cannot use one of the existing methods - even putting aside DUID-EN. Why can you not use DUID-LL, DUID-LLT, or DUID-UUID?

And, with DUID-EN, you can do whatever you want without anyone's input - of course, whether that usage is a good idea is a separate question. Yes, it may have a few additional bytes more than DUID-V6ADDR, but that hardly seems like a useful argument at this point as we still don't know why this is better than the existing DUID types for a STANDARDIZED type.

I still see no text in the 00 or 01 draft about why you need this over the existing methods - i.e., why none of the existing methods will work.

The other thing about a standardized DUID is that you have to assure it is not misused or misunderstood how it should be used. So, you need to be clear about when it MAY be used and when it MUST NOT be used. 

- Bernie

-----Original Message-----
From: dhcwg <[email-masked]> On Behalf Of Simon Hobson
Sent: Friday, January 15, 2021 9:08 AM
To: dhcwg <[email-masked]>; IPv6 List <[email-masked]>
Subject: Re: [dhcwg] [EXTERNAL] Re: I-D Action: draft-templin-duid-ipv6-01.txt

Templin (US), Fred L <[email-masked]> wrote:

> And, I said that if it were *truly* opaque to *all* examinations and 
> references, then there would only ever be *one* DUID type for all 
> time. But, RFC8415 clearly shows that multiple DUID types are defined 
> and that new ones can be added through future standards action.

Simon

---

From: "Templin (US), Fred L" <[email-masked]>
Date: Fri, 15 Jan 2021 18:57:20 +0000

To everyone who has commented, this is the particular exchange for which
I have been expecting but have not received follow-up discussion on the
answer I provided. I will not answer any more questions, because I would
simply be reiterating the same answer I provided in this exchange below.

If I get no follow-discussion (especially from Bob Hinden) I will consider the
DUID-V6ADDR idea "dead" and revert to using DUID-UUID to encode 128-bit
values of all types *even if they are not UUIDs*. Would everyone be cool
with that?

Fred

> Sent: Thursday, January 14, 2021 11:46 AM

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Fri, 15 Jan 2021 20:21:42 +0000

If you're specifying requirements for a closed network in which you are not mixing other devices (i.e. ones that might use real UUIDs), I am not sure I/we can say much.

But if this is an open network where a mix of clients operate (or might in the future), I would be against doing this. Again, use DUID-EN in that case (the 4-6 extra bytes should not be an issue - you don't necessarily need the 2-byte type or you could even use a 1-byte type or no type; you can always get a new enterprise-id if you need a different format in the future).

- Bernie

-----Original Message-----
From: dhcwg <[email-masked]> On Behalf Of Templin (US), Fred L
Sent: Friday, January 15, 2021 1:57 PM
To: Bob Hinden <[email-masked]>
Cc: dhcwg <[email-masked]>; IPv6 List <[email-masked]>; Dickson (US), Sean M <[email-masked]>
Subject: Re: [dhcwg] [EXTERNAL] Re: I-D Action: draft-templin-duid-ipv6-01.txt

To everyone who has commented, this is the particular exchange for which I have been expecting but have not received follow-up discussion on the answer I provided. I will not answer any more questions, because I would simply be reiterating the same answer I provided in this exchange below.

If I get no follow-discussion (especially from Bob Hinden) I will consider the DUID-V6ADDR idea "dead" and revert to using DUID-UUID to encode 128-bit values of all types *even if they are not UUIDs*. Would everyone be cool with that?

Fred

> > Cc: Bob Hinden <[email-masked]>; dhcwg <[email-masked]>; IPv6 
> > List <[email-masked]>; Dickson (US), Sean M 
> > > Bob, I think the answer to your question is quite simple. RFC8415, 
> > > Section 11 provides the motivation for having more than one type 
> > > of DUID, and RFC6355 is an example of how new DUID types are added through standards action.
> > > The precedent for adding new DUID types according to published 
> > > procedures is therefore established.
> >
> A different poster (Ole) made an assertion that seemed to call into 
> question why more than one DUID type is necessary - the above text was 
> included to to justify why multiple DUIDs are provided by RFC8415, and 
> why additional DUIDs can be added through future standards actions.
> 
> > I asked:
> >
> > > In the specific instance of the proposal for establishing a new 
> > > DUID type to carry an IPv6 address, the intended use case is for 
> > > IPv6 address generation methods that produce an address that is 
> > > designed to be a unique and stable identifier for the node, which 
> > > meets the requirements of what can be used as a DUID per RFC8415, 
> > > Section 11. This is certainly the case for (H)HIT per RFC7401 and 
> > > draft-ietf-drip-rid, and I suppose the same case could be made for 
> > > other cryptographically generated IPv6 addresses such as RFC3972. 
> > > Future IPv6 address generation methods (whether or not 
> > > cryptographic) could also be designed to produce a unique and stable identifier for the node, and would be covered under the proposed new DUID type as well.
> >
> [RFC7401] and [draft-ietf-drip-rid] are examples of IPv6 address 
> generation methods that generate an address intended to be used as an 
> *identity* but possible not as a *locator*. In other words, the 
> address could appear in control message ID fields but may or may not 
> be "ping'able" in the data plane. And, even if it were "ping'able", 
> pervasive use of the address for data communications could present an unacceptable privacy exposure.
> 
> Continuing from what I said above, yes this would entail using one 
> type of IPv6 address (a pure identifier) to obtain one or more IPv6 
> addresses or prefixes that can be used as the source/destination addresses for IPv6 data plane packets.
> 
> Fred
> 
> > Bob
> >
> >
> > >
> > > Before we go down the rathole of "IPv6 addresses must be assigned 
> > > to an interface and not a node", please refer to the earlier 
> > > messages on this thread where the suggestion was made that the 
> > > stable and unique address could be assigned to a virtual interface 
> > > (e.g., a loopback) and not an interface that may be subject to 
> > > change such as due to a hot-swap of an interface card. Finally,
> > > From this text, we see that an IPv6 address may be used as an 
> > > identifier for the node, which is exactly what a DUID is. And, an 
> > > IPv6 address is unlike any of the existing DUID types, since by 
> > > definition the address must be in the format specified by RFC4291. Hence, a new DUID type is requested.
> > >
> > > Fred
> > >
> > >> Bob, I have been offline until just now due to windstorms that 
> > >> knocked out power and Internet access in the Seattle area over 
> > >> the past couple of days. I will reply to your question shortly.
> > >>
> > >> Fred
> > >>
> > >>> Cc: Bob Hinden <[email-masked]>; Ole Trøan 
> > >>> <[email-masked]>; dhcwg <[email-masked]>; IPv6 List
> > >> <[email-masked]>;
> > >>>>> Cc: Bob Hinden <[email-masked]>; dhcwg <[email-masked]>; 
> > >>>>> 6man WG <[email-masked]>; Dickson (US), Sean M 
> > >>>>>  "Clients and servers MUST treat DUIDs as opaque values and 
> > >>>>> MUST only  compare DUIDs for equality.  Clients and servers 
> > >>>>> SHOULD NOT in any  other way interpret DUIDs."
> > >>>>
> > >>>> Yes, but then what is the reason why we currently have 4 DUID 
> > >>>> types instead of just 1? If the text you quoted above is all 
> > >>>> there was to it, and end of story, there would never be a need 
> > >>>> to differentiate DUID-LL from DUID-LLA from DUID-EN from 
> > >>>> DUID-UUID. So, this suggests there is more to the story than 
> > >>>> just the short text you quoted above. And, the community has supported the definition of new DUIDs in the past (e.g., DUID-UUID).
> > >>>>
> > >>>> Thanks - Fred
> > >>>>
> > >>>>> Best regards,
> > >>>>> Ole
> > >>>>>
> > >>>>>> Per your comment, perhaps a new section on "motivation" could 
> > >>>>>> be added to the draft?
> > >>>>>>
> > >>>>>> Thanks - Fred
> > >>>>>>
> > >>>>>>> Cc: Bob Hinden <[email-masked]>; Mark Smith 
> > >>>>>>> <[email-masked]>; dhcwg <[email-masked]>; IPv6 List 
> > >>>>>>> "I don't understand what problem this is trying to solve or 
> > >>>>>>> see any benefits of it. What is wrong with existing DUIDs?”
> > >>>>>>>
> > >>>>>>>> Mark, thanks for the comments. I gather your concern is for 
> > >>>>>>>> the longevity and immutability of the IPv6 address that 
> > >>>>>>>> would go into the DUID, since DUIDs are meant to identify 
> > >>>>>>>> the device and not change over time. But, there are IPv6 
> > >>>>>>>> address generation methods that generate addresses not for 
> > >>>>>>>> the purpose of assigning them to a physical interface 
> > >>>>>>>> (e.g., Ethernet, WiFi and the like), but instead to provide 
> > >>>>>>>> a unique node ID for the device that never changes 
> > >>>>>>>> [RFC7401][draft-ietf-drip-rid]. Also, [RFC7721] mentions 
> > >>>>>>>> several other IPv6 address generation methods that could be considered for use for generating a unique node ID, and other IPv6 address generation methods intended to create a unique node ID could be defined in the future.
> > >>>>>>>>
> > >>>>>>>> So, again, this is not about using an IPv6 address assigned 
> > >>>>>>>> to a physical interface as a DUID; it is about using an 
> > >>>>>>>> IPv6 address that was intentionally generated to be a unique identifier for the node and may also be assigned to a virtual interface.
> > >>>>>>>>
> > >>>>>>>> Thanks - Fred
> > >>>>>>>>
> > >>>>>>>>> I don't understand what problem this is trying to solve or 
> > >>>>>>>>> see any benefits of it. What is wrong with existing DUIDs?
> > >>>>>>>>>
> > >>>>>>>>> "...  designed to be unique across all DHCP clients and 
> > >>>>>>>>> servers, and stable for any specific client or server.  
> > >>>>>>>>> That is, the DUID used by a client or server SHOULD NOT 
> > >>>>>>>>> change over time if at all possible; for example, a 
> > >>>>>>>>> device's DUID should not change as a result of a change in 
> > >>>>>>>>> logical PPP (over Ethernet) interfaces that may come and 
> > >>>>>>>>> go in Customer Premises Equipment routers).  The client 
> > >>>>>>>>> may change its DUID as specified in [RFC7844]."
> > >>>>>>>>>
> > >>>>>>>>> The only IPv6 address that I can think of that might come 
> > >>>>>>>>> close to meeting those requirements would be an EUI-64 
> > >>>>>>>>> derived Link-Local address, and that is assuming that the 
> > >>>>>>>>> EUI-64/hardware MAC address never changes. MAC address 
> > >>>>>>>>> randomisation and the RFC8064 recommendation for use of 
> > >>>>>>>>> RFC7217 for SLAAC means that Link-Local addresses may not 
> > >>>>>>>>> meet the DUID requirements above either (RFC7217 can 
> > >>>>>>>>> result in link-specific link-local addresses (specifically 
> > >>>>>>>>> the IID portion is link specifc), even though the link-local prefix itself is constant across all links).
> > >>>>>>>>>
> > >>>>>>>>> There's also a circular dependency if the DUID is based on 
> > >>>>>>>>> a GUA or ULA address and DHCPv6 is to then be used for 
> > >>>>>>>>> stateful GAU/ULA address assignment, unless you mandated 
> > >>>>>>>>> that SLAAC and stateful DHCPv6 are used in parallel so 
> > >>>>>>>>> that SLAAC could be used to derive the DUID that is then 
> > >>>>>>>>> used to acquire further ULA/GUA addresses via stateful DHCPv6 IA_NAs and IA_TAs.
> > >>>>>>>>>
> > >>>>>>>>> "The DUID-V6ADDR may appear in DHCPv6 and/or other 
> > >>>>>>>>> protocol control messages (such as IPv6 ND) within a 
> > >>>>>>>>> service domain when a unique ID based on an IPv6 address is required."
> > >>>>>>>>>
> > >>>>>>>>> DHCPv6 Unique Identifiers outside of the DHCP protocol 
> > >>>>>>>>> would be an abuse of a DUID.
> > >>>>>>>>>
> > >>>>>>>>> Regards,
> > >>>>>>>>> Mark.
> > >>>>>>>>>
> > >>>>>>>>>> Hi, more and more IPv6 address generation methods are 
> > >>>>>>>>>> being specified that intend to generate IPv6 addresses 
> > >>>>>>>>>> that are highly likely to be unique on either a global 
> > >>>>>>>>>> scale or unique within a bounded service domain. So much 
> > >>>>>>>>>> so, that some address generation methods intend for the IPv6 addresses to be usable as node identifiers.
> > >>>>>>>>>>
> > >>>>>>>>>> Recognizing this, this document proposes a new DHCPv6 
> > >>>>>>>>>> DUID type known as "DHCP-V6ADDR" that includes an IPv6 
> > >>>>>>>>>> address in the body of the DUID. In this way, IPv6 
> > >>>>>>>>>> addresses produced by address generation methods 
> > >>>>>>>>>> intending to generate a node ID can be used as unique 
> > >>>>>>>>>> identifiers in DHCPv6 message exchanges. This would introduce a single new DUID type, for which the IANA allocation policy is  "standards action".
> > >>>>>>>>>>
> > >>>>>>>>>> Alternatively, a separate DUID type could be allocated 
> > >>>>>>>>>> for each IPv6 address generation method. However, that 
> > >>>>>>>>>> approach may result in additional IANA allocations and 
> > >>>>>>>>>> would require implementation updates every time a new 
> > >>>>>>>>>> address generation method is specified. Hence, a single generic DUID type for all IPv6 generation methods is proposed, but open for discussion.
> > >>>>>>>>>>
> > >>>>>>>>>> This document defines a new DHCPv6 Unique Identifier 
> > >>>>>>>>>> (DUID) type called DUID-V6ADDR that contains a single 128 bit IPv6 address.
> > >>>>>>>>>> DUID-V6ADDR makes it possible for devices to use 
> > >>>>>>>>>> suitably-derived unique IPv6 addresses to identify 
> > >>>>>>>>>> themselves to DHCPv6 servers and/or other network nodes.
> > >>>>>>>>>>
> > >>>>>>>>>>
> > >>>>>>>>>> Please note that it may take a couple of minutes from the 
> > >>>>>>>>>> time of submission until the htmlized version and diff are available at tools.ietf.org.
> > >>>>>>>>>>
> > >>>>>>>>>> I-D-Announce mailing list [email-masked] 
> > >>>>>>>>>> Internet-Draft directories: 
> > >>>>>>>>>> http://www.ietf.org/shadow.html or 
> > >>>>>>>>>> ftp://ftp.ietf.org/ietf/1shadow-sites.txt
> > >>>>>>>>>>
> > >>>>>>>>>> ---------------------------------------------------------
> > >>>>>>>>>> ----------- IETF IPv6 working group mailing list 
> > >>>>>>>>>> [email-masked] Administrative Requests: 
> > >>>>>>>>>> https://www.ietf.org/mailman/listinfo/ipv6
> > >>>>>>>> -----------------------------------------------------------
> > >>>>>>>> --------- IETF IPv6 working group mailing list 
> > >>>>>>>> [email-masked] Administrative Requests: 
> > >>>>>>>> https://www.ietf.org/mailman/listinfo/ipv6
> > >>>>>> -------------------------------------------------------------
> > >>>>>> ------- IETF IPv6 working group mailing list [email-masked] 
> > >>>>>> Administrative Requests: 
> > >>>>>> https://www.ietf.org/mailman/listinfo/ipv6